Index: trunk/kernel/kern/scheduler.c
===================================================================
--- trunk/kernel/kern/scheduler.c	(revision 690)
+++ trunk/kernel/kern/scheduler.c	(revision 1)
@@ -458,211 +72,288 @@
         list_add_last( &sched->k_root , &thread->sched_list );
         sched->k_threads_nr++;
-        if( sched->k_last == NULL ) sched->k_last = &thread->sched_list; 
     }
 
     // release lock 
-    busylock_release( &sched->lock );
-
-}  // end sched_register_thread()
-
-//////////////////////////////////////////////////////////////////
-void sched_yield( const char * cause __attribute__((__unused__)) )
-{
-    thread_t      * next;
-    thread_t      * current = CURRENT_THREAD;
-    core_t        * core    = current->core;
-    lid_t           lid     = core->lid;
-    scheduler_t   * sched   = &core->scheduler;
-    remote_fifo_t * fifo    = &LOCAL_CLUSTER->rpc_fifo[lid]; 
- 
-#if DEBUG_SCHED_YIELD
-uint32_t cycle = (uint32_t)hal_get_cycles();
-#endif
-
-#if (DEBUG_SCHED_YIELD & 0x1)
-if( sched->trace || (cycle > DEBUG_SCHED_YIELD) )
-sched_remote_display( local_cxy , lid );
-#endif
-
-// This assert should always be true, as this check has been
-// done before, by any function that can possibly deschedule...
-assert( __FUNCTION__, (current->busylocks == 0),
-"current thread hold %d busylocks\n", current->busylocks ); 
-
-    // activate or create an RPC thread if RPC_FIFO non empty
-    if( remote_fifo_is_empty( fifo ) == false )  sched_rpc_activate( sched );
-
-    // disable IRQs / save SR in current thread descriptor
-    hal_disable_irq( &current->save_sr );
-
-    // take lock protecting sheduler state
-    busylock_acquire( &sched->lock );
-    
-    // select next thread 
-    next = sched_select( sched );
-
-// check next thread kernel_stack overflow
-assert( __FUNCTION__, (next->signature == THREAD_SIGNATURE),
-"kernel stack overflow for thread %x on core[%x,%d]", next, local_cxy, lid );
-
-// check next thread attached to same core as the current thread
-assert( __FUNCTION__, (next->core == current->core),
-"next_core_lid %d / current_core_lid %d", current->core->lid, next->core->lid );
-   
-// check next thread not blocked when type != IDLE
-assert( __FUNCTION__, ((next->blocked == 0) || (next->type == THREAD_IDLE)) ,
-"next thread %x (%s) is blocked on core[%x,%d]", 
-next->trdid , thread_type_str(next->type) , local_cxy , lid );
-
-    // switch contexts and update scheduler state if next != current
-	if( next != current )
-    {
-        // update scheduler 
-        sched->current = next;
-        if( next->type == THREAD_USER ) sched->u_last = &next->sched_list;
-        else                            sched->k_last = &next->sched_list;
-
-        // handle FPU ownership
-	    if( next->type == THREAD_USER )
+    spinlock_unlock( &sched->lock );
+
+}  // end sched_register()
+
+/////////////////////////////////////////////
+void sched_remove_thread( thread_t * thread )
+{
+    core_t       * core  = thread->core;
+    scheduler_t  * sched = &core->scheduler;
+    thread_type_t  type  = thread->type;
+
+    // take lock protecting sheduler lists
+    spinlock_lock( &sched->lock );
+
+    // remove thread
+    if( type == THREAD_USER )
+    {
+        list_unlink( &thread->sched_list );
+        sched->u_threads_nr--;
+    }
+    else // kernel thread 
+    {
+        list_unlink( &thread->sched_list );
+        sched->k_threads_nr--;
+    }
+
+    // release lock
+    spinlock_unlock( &sched->lock );
+
+}  // end sched_remove()
+
+///////////////////////////////////////////
+void sched_kill_thread( thread_t * thread )
+{
+    // check thread locks
+    if( thread_can_yield() == false )
+    {
+        printk("\n[ERROR] in %s : thread %x in process %x on core %d in cluster %x"
+               " did not released all locks\n",
+               __FUNCTION__ , thread->trdid , thread->process->pid, 
+               thread->core->lid , local_cxy ); 
+        hal_core_sleep();
+    }
+
+    // remove thread from scheduler
+    sched_remove_thread( thread );
+
+    // reset the THREAD_SIG_KILL signal
+    thread_reset_signal( thread , THREAD_SIG_KILL );
+
+}  // end sched_kill_thread()
+
+////////////////////////////////////////
+thread_t * sched_select( core_t * core )
+{
+    thread_t * thread;
+
+    scheduler_t * sched = &core->scheduler;
+
+    // take lock protecting sheduler lists
+    spinlock_lock( &sched->lock );
+
+    list_entry_t * current;
+    list_entry_t * last;
+
+    // first scan the kernel threads
+    last    = sched->k_last;
+    current = sched->k_last;
+    do
+    {
+        // get next entry in kernel list
+        current = list_next( &sched->k_root , current );
+
+        // skip the list root that does not contain a thread
+        if( current == NULL ) continue;
+
+        // get thread pointer
+        thread = LIST_ELEMENT( current , thread_t , sched_list );
+
+        // return thread if not blocked
+        if( thread->blocked == 0 ) 
         {
-	        if( next == current->core->fpu_owner )  hal_fpu_enable();
-	        else                                    hal_fpu_disable();
+            // release lock 
+            spinlock_unlock( &sched->lock );
+            return thread;
         }
-
-        // release lock protecting scheduler state
-        busylock_release( &sched->lock );
-
-#if DEBUG_SCHED_YIELD
-if( sched->trace || (cycle > DEBUG_SCHED_YIELD) )
-printk("\n[%s] core[%x,%d] / cause = %s\n"
-"      thread %x (%s) (%x,%x) => thread %x (%s) (%x,%x) / cycle %d\n",
-__FUNCTION__, local_cxy, lid, cause, 
-current, thread_type_str(current->type), current->process->pid, current->trdid,next ,
-thread_type_str(next->type) , next->process->pid , next->trdid , cycle );
-#endif
-
-        // switch CPU from current thread context to new thread context
-        hal_do_cpu_switch( current->cpu_context, next->cpu_context );
-    }
-    else
-    {
-        // release lock protecting scheduler state
-        busylock_release( &sched->lock );
-
-#if DEBUG_SCHED_YIELD 
-if( sched->trace || (cycle > DEBUG_SCHED_YIELD) )
-printk("\n[%s] core[%x,%d] / cause = %s\n"
-"      thread %x (%s) (%x,%x) continue / cycle %d\n",
-__FUNCTION__, local_cxy, lid, cause, current, thread_type_str(current->type),
-current->process->pid, current->trdid, (uint32_t)hal_get_cycles() );
-#endif
-
-    }
-
-    // handle pending requests for all threads executing on this core.
+    }
+    while( current != last );
+
+    // second scan the user threads
+    last    = sched->u_last;
+    current = sched->u_last;
+    do
+    {
+        // get next entry in user list
+        current = list_next( &sched->u_root , current );
+
+        // skip the list root that does not contain a thread
+        if( current == NULL ) continue;
+
+        // get thread pointer
+        thread = LIST_ELEMENT( current , thread_t , sched_list );
+
+        // return thread if not blocked
+        if( thread->blocked == 0 )
+        {
+            // release lock 
+            spinlock_unlock( &sched->lock );
+            return thread;
+        }
+    }
+    while( current != last );
+
+    // release lock 
+    spinlock_unlock( &sched->lock );
+
+    // third, return idle thread if no runnable thread
+    return sched->idle;
+
+}  // end sched_elect()
+
+//////////////////////////////////////////
+void sched_handle_signals( core_t * core )
+{
+    list_entry_t * iter;
+    thread_t     * thread;
+
+    scheduler_t  * sched = &core->scheduler;
+
+    // take lock protecting threads lists
+    spinlock_lock( &sched->lock );
+
+    // handle user threads
+    LIST_FOREACH( &sched->u_root , iter )
+    {
+        thread = LIST_ELEMENT( iter , thread_t , sched_list );
+        if( thread->signals & THREAD_SIG_KILL )  sched_kill_thread( thread );
+    }
+
+    // handle kernel threads
+    LIST_FOREACH( &sched->k_root , iter )
+    {
+        thread = LIST_ELEMENT( iter , thread_t , sched_list );
+        if( thread->signals & THREAD_SIG_KILL )  sched_kill_thread( thread );
+    }
+
+    // release lock 
+    spinlock_unlock( &sched->lock );
+
+} // end sched_handle_signals()
+
+//////////////////
+void sched_yield()
+{
+    uint32_t      sr_save;
+    thread_t    * next;
+
+    thread_t    * current = CURRENT_THREAD;
+    core_t      * core    = current->core;
+
+    if( thread_can_yield() == false )
+    {
+        printk("\n[PANIC] in %s : thread %x for process %x on core %d in cluster %x"
+               " has not released all locks\n",
+               __FUNCTION__, current->trdid, current->process->pid, core->lid, local_cxy );
+        hal_core_sleep();
+    }
+
+    // desactivate IRQs
+    hal_disable_irq( &sr_save );
+
+    // first loop on all threads to handle pending signals
     sched_handle_signals( core );
 
-    // exit critical section / restore SR from current thread descriptor
-    hal_restore_irq( CURRENT_THREAD->save_sr );
+    // second loop on threads to select next thread
+    next = sched_select( core );
+
+    // check stack overflow for selected thread
+    if( next->signature != THREAD_SIGNATURE )
+    {
+        printk("\n[PANIC] in %s : detected stack overflow for thread %x of process %x"
+               " on core %d in cluster %x\n",
+               __FUNCTION__, next->trdid, next->process->pid, core->lid, local_cxy);
+        hal_core_sleep();
+	}
+	
+	sched_dmsg("\n[INFO] %s on core %d in cluster %x / old thread = %x / new thread = %x\n",
+               __FUNCTION__, core->lid, cluster->cxy, current->trdid, next->trdid );
+
+    // switch contexts if new thread
+	if( next != current )  
+	{
+        hal_cpu_context_save( current );
+        hal_cpu_context_restore( next );
+	}
+
+    // restore IRQs
+    hal_restore_irq( sr_save );
+
+	if( current->type != THREAD_USER ) return;
+
+	if( current == core->fpu_owner )  hal_fpu_enable();
+	else                              hal_fpu_disable();
 
 }  // end sched_yield()
 
-
-/////////////////////////////////////
-void sched_remote_display( cxy_t cxy,
-                           lid_t lid )
-{
-    thread_t     * thread;
-
-    // get local pointer on target scheduler
-    core_t      * core  = &LOCAL_CLUSTER->core_tbl[lid];
-    scheduler_t * sched = &core->scheduler;
-
-    // get local pointer on current thread in target scheduler
-    thread_t * current = hal_remote_lpt( XPTR( cxy, &sched->current ) );
-
-    // get local pointer on the first kernel and user threads list_entry
-    list_entry_t * k_entry = hal_remote_lpt( XPTR( cxy , &sched->k_root.next ) );
-    list_entry_t * u_entry = hal_remote_lpt( XPTR( cxy , &sched->u_root.next ) );
-    
-    // get pointers on TXT0 chdev
-    xptr_t    txt0_xp  = chdev_dir.txt_tx[0];
-    cxy_t     txt0_cxy = GET_CXY( txt0_xp );
-    chdev_t * txt0_ptr = GET_PTR( txt0_xp );
-
-    // get extended pointer on remote TXT0 chdev lock
-    xptr_t  lock_xp = XPTR( txt0_cxy , &txt0_ptr->wait_lock );
-
-    // get TXT0 lock 
-    remote_busylock_acquire( lock_xp );
-
-    // get rpc_threads
-    uint32_t rpcs = hal_remote_l32( XPTR( cxy , &LOCAL_CLUSTER->rpc_threads[lid] ) );
- 
-    // display header
-    nolock_printk("\n***** threads on core[%x,%d] / current %x / rpc_threads %d / cycle %d\n",
-    cxy , lid, current, rpcs, (uint32_t)hal_get_cycles() );
-    nolock_printk("  type | pid        | trdid      | desc       | block      | flags      | func\n");
-
-    // display kernel threads
-    while( k_entry != &sched->k_root )
-    {
-        // get local pointer on kernel_thread
-        thread = LIST_ELEMENT( k_entry , thread_t , sched_list );
-
-        // get relevant thead info
-        thread_type_t type    = hal_remote_l32 ( XPTR( cxy , &thread->type ) );
-        trdid_t       trdid   = hal_remote_l32 ( XPTR( cxy , &thread->trdid ) );
-        uint32_t      blocked = hal_remote_l32 ( XPTR( cxy , &thread->blocked ) );
-        uint32_t      flags   = hal_remote_l32 ( XPTR( cxy , &thread->flags ) );
-        process_t *   process = hal_remote_lpt ( XPTR( cxy , &thread->process ) );
-        pid_t         pid     = hal_remote_l32 ( XPTR( cxy , &process->pid ) );
-
-        // display thread info
-        if (type == THREAD_DEV) 
-        {
-            char      name[16];
-            chdev_t * chdev = hal_remote_lpt( XPTR( cxy , &thread->chdev ) );
-            hal_remote_strcpy( XPTR( local_cxy , name ), XPTR( cxy , chdev->name ) );
-
-            nolock_printk(" - %s | %X | %X | %X | %X | %X | %s\n",
-            thread_type_str( type ), pid, trdid, thread, blocked, flags, name );
-        }
-        else
-        {
-            nolock_printk(" - %s | %X | %X | %X | %X | %X |\n",
-            thread_type_str( type ), pid, trdid, thread, blocked, flags );
-        }
-
-        // get next remote kernel thread list_entry
-        k_entry = hal_remote_lpt( XPTR( cxy , &k_entry->next ) );
-    }
-
-    // display user threads
-    while( u_entry != &sched->u_root )
-    {
-        // get local pointer on user_thread
-        thread = LIST_ELEMENT( u_entry , thread_t , sched_list );
-
-        // get relevant thead info
-        thread_type_t type    = hal_remote_l32 ( XPTR( cxy , &thread->type ) );
-        trdid_t       trdid   = hal_remote_l32 ( XPTR( cxy , &thread->trdid ) );
-        uint32_t      blocked = hal_remote_l32 ( XPTR( cxy , &thread->blocked ) );
-        uint32_t      flags   = hal_remote_l32 ( XPTR( cxy , &thread->flags ) );
-        process_t *   process = hal_remote_lpt ( XPTR( cxy , &thread->process ) );
-        pid_t         pid     = hal_remote_l32 ( XPTR( cxy , &process->pid ) );
-        void      *   func    = hal_remote_lpt ( XPTR( cxy , &thread->entry_func ) );
-
-        nolock_printk(" - %s | %X | %X | %X | %X | %X | %x\n",
-        thread_type_str( type ), pid, trdid, thread, blocked, flags, (uint32_t)func );
-
-        // get next user thread list_entry
-        u_entry = hal_remote_lpt( XPTR( cxy , &u_entry->next ) );
-    }
-
-    // release TXT0 lock
-    remote_busylock_release( lock_xp );
-
-}  // end sched_remote_display()
-
-
+//////////////////////////////////////
+void sched_switch_to( thread_t * new )
+{
+    uint32_t      sr_save;
+
+    thread_t    * current = CURRENT_THREAD;
+    core_t      * core    = current->core;
+    process_t   * process = current->process;
+
+    // check calling thread released all locks
+    if( thread_can_yield() == false )
+    {
+        printk("\n[PANIC] in %s : thread %x for process %x on core %d in cluster %x"
+               " has not released all locks\n",
+               __FUNCTION__, current->trdid, process->pid, core->lid, local_cxy );
+        hal_core_sleep();
+    }
+
+    // check new thread attached to same core as the calling thread
+    if( new->core != current->core )
+    {
+        printk("\n[PANIC] in %s : new thread %x is attached to core %d"
+               " different from core %d of current thread\n",
+               __FUNCTION__, new->trdid, new->core->lid, core->lid , current->trdid );
+        hal_core_sleep();
+    }
+
+    // check new thread not blocked
+    if( new->blocked == 0 )
+    {
+        printk("\n[PANIC] in %s for thread %x of process %x on core %d in cluster %x"
+               " : new thread %x is blocked\n",
+               __FUNCTION__, current->trdid, process->pid , core->lid, local_cxy , new->trdid );
+        hal_core_sleep();
+    }
+
+    // check stack overflow for new thread
+    if( new->signature != THREAD_SIGNATURE )
+    {
+        printk("\n[PANIC] in %s : stack overflow for new thread %x of process %x"
+               " on core %d in cluster %x\n",
+               __FUNCTION__, new->trdid, process->pid , core->lid , local_cxy );
+        hal_core_sleep();
+	}
+
+    // desactivate IRQs
+    hal_disable_irq( &sr_save );
+
+    // loop on all threads to handle pending signals
+    sched_handle_signals( core );
+
+    // check stack overflow for new thread
+    if( new->signature != THREAD_SIGNATURE )
+    {
+        printk("PANIC %s detected stack overflow for thread %x of process %x"
+               " on core %d in cluster %x\n",
+               __FUNCTION__, new->trdid, new->process->pid, core->lid, local_cxy);
+        hal_core_sleep();
+	}
+	
+	sched_dmsg("INFO : %s on core %d in cluster %x / old thread = %x / new thread = %x\n",
+               __FUNCTION__, core->lid, cluster->cxy, current->trdid, new->trdid );
+
+    // switch contexts if new thread
+    hal_cpu_context_save( current );
+    hal_cpu_context_restore( new );
+
+    // restore IRQs
+    hal_restore_irq( sr_save );
+
+	if( current->type != THREAD_USER ) return;
+
+	if( current == core->fpu_owner )  hal_fpu_enable();
+	else                              hal_fpu_disable();
+
+}  // end sched_switch_to()
+
Index: trunk/kernel/kern/scheduler.h
===================================================================
--- trunk/kernel/kern/scheduler.h	(revision 690)
+++ trunk/kernel/kern/scheduler.h	(revision 1)
@@ -2,5 +2,5 @@
  * scheduler.h - Core scheduler definition.
  * 
- * Author    Alain Greiner       (2016,2017,2018,2019,2020)
+ * Author    Alain Greiner (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -25,7 +25,7 @@
 #define _SCHEDULER_H_
 
-#include <hal_kernel_types.h>
+#include <hal_types.h>
 #include <list.h>
-#include <busylock.h>
+#include <spinlock.h>
 
 /****  Forward declarations  ****/
@@ -34,69 +34,108 @@
 struct thread_s;
 
-/*********************************************************************************************
+/***********************************************************************************************
  * This structure define the scheduler associated to a given core.
- ********************************************************************************************/
+ * WARNING : the idle thread is executed when there is no runable thread in the list 
+ * of attached threads, but is NOT part of the list of attached threads.
+ **********************************************************************************************/
 
 typedef struct scheduler_s
 {
-    busylock_t        lock;            /*! lock protecting scheduler state                  */
-    uint32_t          u_threads_nr;    /*! total number of attached user threads            */
-    uint32_t          k_threads_nr;    /*! total number of attached kernel threads          */
-    list_entry_t      u_root;          /*! root of list of user threads                     */
-    list_entry_t      k_root;          /*! root of list of kernel threads                   */
-    list_entry_t    * u_last;          /*! pointer on list_entry for last executed k_thread */
-    list_entry_t    * k_last;          /*! pointer on list entry for last executed u_thread */
-    struct thread_s * idle;            /*! pointer on idle thread                           */
-    struct thread_s * current;         /*! pointer on current running thread                */
-    volatile bool_t   req_ack_pending; /*! sequencialize ack requests when true             */
-    bool_t            trace;           /*! context switches trace activated if true         */
+    spinlock_t        lock;         /*! readlock protecting lists of threads                  */
+    uint16_t          u_threads_nr; /*! total numbre of attached user threads                 */
+    uint16_t          k_threads_nr; /*! total number of attached kernel threads               */
+    list_entry_t      u_root;       /*! root of list of user threads for this scheduler       */
+    list_entry_t      k_root;       /*! root of list of kernel threads for this scheduler     */
+    list_entry_t    * u_last;       /*! pointer on list_entry for last executed kernel thread */
+    list_entry_t    * k_last;       /*! pointer on list entry for last executed user thread   */
+    struct thread_s * idle;         /*! pointer on idle thread                                */
+    struct thread_s * current;      /*! pointer on current running thread                     */
 }
 scheduler_t;
 
-/*********************************************************************************************
- *  This function initialises the scheduler for a given core.
- ********************************************************************************************/  
+/***********************************************************************************************
+ *  This function initialises the scheduler for a ginen core.
+ **********************************************************************************************/  
 void sched_init( struct core_s * core );
 
-/*********************************************************************************************
- * This function atomically register a new thread in a given core scheduler.
- * Note: There is no specific sched_remove_thread(), as a thread is always deleted
- * by the ched_handle_signals() function, called by the sched_yield() function.
- *********************************************************************************************
+/***********************************************************************************************
+ * This function register a new thread in a given core scheduler.
+ ***********************************************************************************************
  * @ core    : local pointer on the core descriptor.
  * @ thread  : local pointer on the thread descriptor.
- ********************************************************************************************/  
+ **********************************************************************************************/  
 void sched_register_thread( struct core_s   * core,
                             struct thread_s * thread );
 
-/********************************************************************************************* 
- * This function is the only method to make a context switch. It is called in cas of TICK,
- * or when a thread explicitely requires to be descheduled.
- * It takes the scheduler busylock to atomically update the scheduled state.
- * It calls the sched_select() private function to select a new thread. After switch, it 
- * calls the sched_handle_signals() private function to handle the pending REQ_ACK and 
- * REQ_DELETE flagss for all threads attached to the scheduler: it deletes all threads 
- * marked for delete (and the process descriptor when the deleted thread is the main thread).
- * As the REQ_DELETE flag can be asynchronously set (between the select and the handle),
- * the sched_handle-signals() function check that the thread to delete is not the new thread,
- * because a thread cannot delete itself.
- * The cause argument is only used for debug by the sched_display() functions, and indicates
- * the scheduling cause.
- *********************************************************************************************
- * @ cause    : character string defining the scheduling cause.
- ********************************************************************************************/
-void sched_yield( const char * cause );
+/*********************************************************************************************** 
+ *  This function removes a thread from the set of threads attached to a given core.
+ ***********************************************************************************************
+ * @ thread  : local pointer on the thread descriptor.
+ **********************************************************************************************/  
+void sched_remove_thread( struct thread_s * thread );
 
-/********************************************************************************************* 
- * This debug function displays on TXT0 the internal state of a scheduler, 
- * identified by the target cluster identifier <cxy> and the core local index <lid>.
- * It can be called by a thread running in any cluster, as it uses remote accesses,
- * to scan the scheduler lists of threads.
- *********************************************************************************************
- * @ cxy      : target cluster identifier
- * @ lid      : local index of target core.
- ********************************************************************************************/
-void sched_remote_display( cxy_t  cxy,
-                           lid_t  lid );
+/*********************************************************************************************** 
+ * This function handles pending signals for all registered threads, and tries to make 
+ * a context switch for the core running the calling thread.
+ * - If there is a runable thread (other than the current thread or the idle thread),
+ *   the calling thread is descheduled, but its state is not modified.
+ * - If there is no other runable thread, the calling thread continues execution.
+ * - If there is no runable thread, the idle thread is executed.
+ **********************************************************************************************/
+void sched_yield();
+
+/*********************************************************************************************** 
+ * This function handles pending signals for all registered threads, and make 
+ * a context switch to the thread defined by the <thread> argument.
+ * If the selected thread is not attached to the same core as the calling thread,
+ * or is blocked, it causes a kernel panic.
+ ***********************************************************************************************
+ * @ new   : local pointer on the thread to run.
+ **********************************************************************************************/
+void sched_switch_to( struct thread_s * new );
+
+/***********************************************************************************************
+ * This function scan all threads attached to a given core scheduler, and executes
+ * the relevant actions for pending signals, such as the THREAD_SIG_KILL signal.
+ ***********************************************************************************************
+ * @ core    : local pointer on the core descriptor.
+ **********************************************************************************************/
+void sched_handle_signals( struct core_s * core );
+
+/*********************************************************************************************** 
+ * This function is used by the scheduler of a given core to actually kill a thread that has 
+ * the SIG_KILL signal set (following a thread_exit() or a thread_kill() event).
+ * - It checks that the thread has released all locks => panic otherwise...
+ * - It detach the thread from the local process descriptor.
+ * - It removes the thread from the scheduler.
+ * - It release physical memory allocated for thread descriptor.
+ ***********************************************************************************************
+ * @ thread  : local pointer on the thread descriptor.
+ **********************************************************************************************/
+void sched_kill_thread( struct thread_s * thread );
+
+/***********************************************************************************************
+ * This function does NOT modify the scheduler state.
+ * It just select a thread in the list of attached threads, implementing the following policy: 
+ * 1) it scan the list of kernel threads, from the next thread after the last executed one,
+ *    and returns the first runnable found (can be the current thread).
+ * 2) if no kernel thread found, it scan the list of user thread, from the next thread after
+ *    the last executed one, and returns the first runable found (can be the current thread).
+ * 3) if no runable thread found, it returns the idle thread.
+ ***********************************************************************************************
+ * @ core    : local pointer on the core descriptor.
+ * @ returns pointer on selected thread descriptor
+ **********************************************************************************************/
+struct thread_s * sched_select( struct core_s * core );
+
+/*********************************************************************************************** 
+ * This function scan the list of kernel threads to find an idle (blocked) RPC thread.
+ ***********************************************************************************************
+ * @ core    : local pointer on the core descriptor.
+ * @ returns pointer on RPC thread descriptor / returns NULL if no idle RPC thread.
+ **********************************************************************************************/
+struct thread_s * sched_get_rpc_thead( struct core_s * core );
+
+
 
 #endif	/* _SCHEDULER_H_ */
